
' (C) 2007 i-TECH and Kristopher Windsor

#include once "itech\mylibs\font.bi"
#include once "itech\mylibs\keymouse.bi"

const imenu_option_limit = 512, imenu_option_delimiter = ":::", imenu_option_delimiter_length = len(imenu_option_delimiter)

Type imenu_option
  text As String
  y As Integer
End Type

Dim Shared As imenu_option imenu_options(1 To imenu_option_limit)

Function imenu (byref title as string = "Continue?", Byref _options As String = "No" + imenu_option_delimiter + "Yes", _
  byref cancancel as integer = false, byref clearscreen as integer = false) As Integer

  Dim As Integer a, b, selected, firstoption, optionsonscreen, imenu_option_count, scrolloffset, usemouse
  Dim As String options
  options = imenu_option_delimiter + _options
  if cancancel then options += imenu_option_delimiter + "Cancel"
  imenu_option_count = 0

  a = Instr(options, imenu_option_delimiter)

  'extract options' text from one string
  While Instr(a, options, imenu_option_delimiter)
    imenu_option_count += 1
    b = Instr(a + imenu_option_delimiter_length, options, imenu_option_delimiter)
    If b = 0 Then b = Len(options) + 1
    With imenu_options(imenu_option_count)
      .text = " " + Mid(options, a + imenu_option_delimiter_length, b - a - imenu_option_delimiter_length) + " "
    End With
    a = b
  Wend

  'place and scale options
  For a = 1 To imenu_option_count
    With imenu_options(a)
      .y = font_size_y * (a + a + 2)
    End With
  Next a

  Line universal_image, (0, 0) - (screen_size_x - 1, screen_size_y - 1), &HFF000000, bf
  Put (0, 0), universal_image, alpha, 60 - (not(clearscreen = false)) * 195
  Get (0, 0) - (screen_size_x - 1, screen_size_y - 1), universal_image

  selected = 1: firstoption = 1: optionsonscreen = int((screen_size_y - font_size_y * 4) / (font_size_y * 2))
  if optionsonscreen > imenu_option_count then optionsonscreen = imenu_option_count
  clearkeybuffer
  Do
    updatemouse
    if ismousemoving then usemouse = true
    if usemouse then
      For a = firstoption To firstoption + optionsonscreen - 1
        With imenu_options(a)
          If my > .y - scrolloffset - 2 And my < .y - scrolloffset + font_size_y + 2 Then
            selected = a
          End If
        End With
      Next a
    end if
    if iskeyupping and selected > firstoption then selected -= 1: usemouse = false
    if iskeydowning and selected < firstoption + optionsonscreen - 1 then selected += 1: usemouse = false
    if selected = firstoption and firstoption > 1 then firstoption -= 1
    if selected = firstoption + optionsonscreen - 1 and firstoption + optionsonscreen - 1 < imenu_option_count then firstoption += 1
    scrolloffset = (firstoption - 1) * font_size_y * 2

    Screenlock
    Put (0, 0), universal_image, alpha, 20
    font_display (" " + title + " ", font_center, font_size_y * 2,, true)
    For a = firstoption To firstoption + optionsonscreen - 1
      With imenu_options(a)
       font_display (.text, 10, .y - scrolloffset,, true)
      End With
    Next a
    screenunlock
    With imenu_options(selected)
      Line (0, .y - scrolloffset - 2) - (screen_size_x - 1, .y - scrolloffset + font_size_y + 2), &HFFFFFFFF, b
    End With

    sleep 40: updatekey
    if iskeyescaping and cancancel then return false
  Loop Until iskeymousing

  if cancancel and selected = imenu_option_count then return false
  Return selected
end function
